//***************************************************************************************************************
$Events::DatabaseEvent::Version = "2";
//***************************************************************************************************************
registerOutputEvent(fxDTSBrick, "databaseDump", "",1);
registerOutputEvent(fxDTSBrick, "ifPlayerInDatabase", "",1);
registerOutputEvent(fxDTSBrick, "ifDatabaseRowEquals", "string 10 70\tstring 100 70",1);
registerOutputEvent(fxDTSBrick, "addToBLIDDatabase", "string 10 70\tstring 200 100\tstring 200 100\tstring 200 100",1);
registerOutputEvent(fxDTSBrick, "databaseToDatabase", "string 10 70\tstring 200 100\tstring 200 100\tstring 200 100",1);
registerOutputEvent(fxDTSBrick, "addToBLIDDatabaseADV", "string 10 70\tstring 200 200",1);
registerOutputEvent(fxDTSBrick, "databaseToDatabaseADV", "string 10 70\tstring 200 200",1);
registerOutputEvent(fxDTSBrick, "appendToDatabaseID", "string 10 70\tstring 200 200\tstring 50 60",1);
registerOutputEvent(fxDTSBrick, "setDatabaseRow", "string 10 70\tstring 200 200\tstring 50 60",1);
registerOutputEvent(fxDTSBrick, "RemoveFromBLIDDatabase", "string 10 70",1);
registerInputEvent(fxDTSBrick, "onDataBaseRowEquals", "Self fxDTSBrick\tPlayer Player\tClient GameConnection\tMiniGame MiniGame",1);
registerInputEvent(fxDTSBrick, "onDataBaseRowNotEquals", "Self fxDTSBrick\tPlayer Player\tClient GameConnection\tMiniGame MiniGame",1);
registerInputEvent(fxDTSBrick, "onDatabaseQuery", "Self fxDTSBrick\tPlayer Player\tClient GameConnection\tMiniGame MiniGame",1);
registerInputEvent(fxDTSBrick, "onDatabaseError", "Self fxDTSBrick\tPlayer Player\tClient GameConnection\tMiniGame MiniGame",1);


function fxDTSBrick::onDatabaseQuery(%this, %client)
{
	$inputTarget_self = %this;
	$inputTarget_client = %client;
	$inputTarget_player = %client.player;
	$inputTarget_miniGame = getMiniGameFromObject(%this);
	if(%client.isDoingQuery != true) {
	%client.isDoingQuery = true;
	schedule(1000,0,removeQueryDelay,%client);
	%this.processInputEvent("onDatabaseQuery", %client);
	}
}

function fxDTSBrick::onDataBaseRowEquals(%this, %client)
{
	$inputTarget_self = %this;
	$inputTarget_client = %client;
	$inputTarget_player = %client.player;
	$inputTarget_miniGame = getMiniGameFromObject(%this);
	%this.processInputEvent("onDataBaseRowEquals", %client);
}

function fxDTSBrick::onDataBaseRowNotEquals(%this, %client)
{
	$inputTarget_self = %this;
	$inputTarget_client = %client;
	$inputTarget_player = %client.player;
	$inputTarget_miniGame = getMiniGameFromObject(%this);
	%this.processInputEvent("onDataBaseRowNotEquals", %client);
}

function fxDTSBrick::onDataBaseError(%this, %client)
{
	$inputTarget_self = %this;
	$inputTarget_client = %client;
	$inputTarget_player = %client.player;
	$inputTarget_miniGame = getMiniGameFromObject(%this);
	%this.processInputEvent("onDataBaseError", %client);
}

function fxDTSBrick::ifPlayerInDatabase(%this,%client)
{
   %brick = getBrickGroupFromObject(%this).bl_id;
   if(isFile("config/database/data/event_files/database/"@findClientByBL_ID(%brick).name@"/"@%client.BL_ID@".txt") == false) {
    %this.variableFalse(%client);    
    return;  
   }
   %this.onDatabaseQuery(%client);
   %file = new FileObject();
   %file.openForRead("config/database/data/event_files/database/"@findClientByBL_ID(%brick).name@"/"@%client.BL_ID@".txt");
   
   while(!%file.isEOF())
   {
      // Prevent server from crashing.
      if(!isObject(%file)) {return;}
    %line = %file.readLine();
    if(%line $= "-1")
    {
      %this.variableFalse(%client); 
    } else {
     if(getWord(%line, 0) $= %client.BL_ID)
     {
      %this.variableTrue(%client);  
     }
    }
   }
   
}

function fxDTSBrick::ifDatabaseRowEquals(%this,%row,%compair,%client)
{
   %brick = getBrickGroupFromObject(%this).bl_id;
   if(isFile("config/database/data/event_files/database/"@findClientByBL_ID(%brick).name@"/"@%client.BL_ID@".txt") == false) {
    %this.variableFalse(%client);
    return;  
   }
   %this.onDatabaseQuery(%client);
   %file = new FileObject();
   %file.openForRead("config/database/data/event_files/database/"@findClientByBL_ID(%brick).name@"/"@%client.BL_ID@".txt");
   
   while(!%file.isEOF())
   {
    %line = %file.readLine();
    if(getWord(%line, %row) $= %compair)
    {
      %this.onDataBaseRowEquals(%client); 
    } else {
     if(getWord(%line, %row) !$= %compair)
     {
      %this.onDataBaseRowNotEquals(%client);  
     }
    }
   }
   
}

function fxDTSBrick::addToBLIDDatabase(%this,%BLID,%var1,%var2,%var3,%client)
{
   %brick = getBrickGroupFromObject(%this).bl_id;
   %reader = new FileObject();
   %reader.openForRead("config/database/data/event_files/database/"@findClientByBL_ID(%brick).name@"/"@%BLID@".txt");
   while(!%reader.isEOF()) {
		%line = %reader.readLine();
		%id = getWord(%line, 0);
		if(%id == %BLID) {
			commandToClient(%client, 'MessageBoxOK', "Database Error", "Phrase Error:That ID (" @ %BLID @ ")" SPC "is already in the database!");
			return;	
		}   
   }
   %this.onDatabaseQuery(%client);
   %file = new FileObject();
   %file.openForWrite("config/database/data/event_files/database/"@findClientByBL_ID(%brick).name@"/"@%BLID@".txt");
   %var1 = strReplace(%var1, " ", "");   
   %var2 = strReplace(%var2, " ", "");   
   %var3 = strReplace(%var3, " ", "");
   %file.writeLine(%BLID SPC %var1 SPC %var2 SPC %var3);
   %file.close();
   %file.delete();
}

function fxDTSBrick::databaseToDatabase(%this,%BLID,%var1,%var2,%var3,%client)
{
   %brick = getBrickGroupFromObject(%this).bl_id;
   if(isFile("config/database/data/event_files/database/"@findClientByBL_ID(%brick).name@"/"@%BLID@".txt") == false)
   {
    commandToClient(%client, 'MessageBoxOK', "Database Error", "Phrase Error:Unknown Database");
    %this.onDataBaseError(%client);
    return;  
   }
   %reader = new FileObject();
   %reader.openForRead("config/database/data/event_files/database/"@findClientByBL_ID(%brick).name@"/"@%BLID@".txt");
   while(!%reader.isEOF()) {
		%line = %reader.readLine();
		%id = getWord(%line, 0);
		if(%id == %BLID) {
			commandToClient(%client, 'MessageBoxOK', "Database Error", "Phrase Error:That ID (" @ %BLID @ ")" SPC "is already in the database!");
			return;	
		}   
   }
   %this.onDatabaseQuery(%client);
   %file = new FileObject();
   %file.openForAppend("config/database/data/event_files/database/"@findClientByBL_ID(%brick).name@"/"@%BLID@".txt");
   %var1 = strReplace(%var1, " ", "");   
   %var2 = strReplace(%var2, " ", "");   
   %var3 = strReplace(%var3, " ", "");   
   %file.writeLine(%BLID SPC %var1 SPC %var2 SPC %var3);
   %file.close();
   %file.delete();
}

function fxDTSBrick::addToBLIDDatabaseADV(%this,%BLID,%var1,%client)
{
   %brick = getBrickGroupFromObject(%this).bl_id;
   %reader = new FileObject();
   %reader.openForRead("config/database/data/event_files/database/"@findClientByBL_ID(%brick).name@"/"@%BLID@".txt");
   while(!%reader.isEOF()) {
		%line = %reader.readLine();
		%id = getWord(%line, 0);
		if(%id == %BLID) {
			commandToClient(%client, 'MessageBoxOK', "Database Error", "Phrase Error:That ID (" @ %BLID @ ")" SPC "is already in the database!");
			return;	
		}   
   }
   %this.onDatabaseQuery(%client);
   %file = new FileObject();
   %file.openForWrite("config/database/data/event_files/database/"@findClientByBL_ID(%brick).name@"/"@%BLID@".txt"); 
   %file.writeLine(%BLID SPC %var1);
   %file.close();
   %file.delete();
}

function fxDTSBrick::databaseToDatabaseADV(%this,%BLID,%var1,%client)
{
   %brick = getBrickGroupFromObject(%this).bl_id;
   if(isFile("config/database/data/event_files/database/"@findClientByBL_ID(%brick).name@"/"@%BLID@".txt") == false)
   {
    commandToClient(%client, 'MessageBoxOK', "Database Error", "Phrase Error:That ID (" @ %BLID @ ")" SPC "is already in the database!");
    %this.onDataBaseError(%client);
    return;  
   }
   
   %reader = new FileObject();
   %reader.openForRead("config/database/data/event_files/database/"@findClientByBL_ID(%brick).name@"/"@%BLID@".txt");
   %reader = new FileObject();
   %reader.openForRead("config/database/data/event_files/database/"@findClientByBL_ID(%brick).name@"/"@%BLID@".txt");
   while(!%reader.isEOF()) {
		%line = %reader.readLine();
		%id = getWord(%line, 0);
		if(%id == %BLID) {
			commandToClient(%client, 'MessageBoxOK', "Database Error", "Phrase Error:That ID (" @ %BLID @ ")" SPC "is already in the database!");
			return;	
		}   
   }
   
   %this.onDatabaseQuery(%client);
   %file = new FileObject();
   %file.openForAppend("config/database/data/event_files/database/"@findClientByBL_ID(%brick).name@"/"@%BLID@".txt"); 
   %file.writeLine(%BLID SPC %var1);
   %file.close();
   %file.delete();
}

function fxDTSBrick::databaseDump(%this,%client)
{
   %results = 0;
   %brick = getBrickGroupFromObject(%this).bl_id;
   %file = new FileObject();
   %dumpTarget = FindFirstFile("config/database/data/event_files/database/"@findClientByBL_ID(%brick).name@"/*.txt");
   while(strLen(%dumpTarget) > 0) {
    %file.openForRead(%dumpTarget);
    while(!%file.isEOF()) {
    %line = %file.readLine();
    if(%line !$= "") {
	%results++;
    messageClient(%client, '', '\c3[Database Dump]:\c6 %1', %line);
    }
    }
    %dumpTarget = FindNextFile("config/database/data/event_files/database/"@findClientByBL_ID(%brick).name@"/*.txt");
   }
   if(%results <= 0) {
   		messageClient(%client, '', "\c3[Database Dump]:\c6 No Results Found!");   
   }
}

function fxDTSBrick::appendToDatabaseID(%this,%BLID,%var1,%table,%client)
{
   if(%table <= 0)
   {
     commandToClient(%client, 'MessageBoxOK', "Database Error", "Phrase Error:\nUnable to select row:" SPC %table);
     return;
   }
   %count = 0;
   %brick = getBrickGroupFromObject(%this).bl_id;
   if(isFile("config/database/data/event_files/database/"@findClientByBL_ID(%brick).name@"/"@%BLID@".txt") == false)
   {
    commandToClient(%client, 'MessageBoxOK', "Database Error", "Phrase Error:Unknown Database");
    %this.onDataBaseError(%client);
    return;  
   }
   %reader = new FileObject();
   %reader.openForRead("config/database/data/event_files/database/"@findClientByBL_ID(%brick).name@"/"@%BLID@".txt");
   %file = new FileObject();
   %file.openForWrite("config/database/data/event_files/database/"@findClientByBL_ID(%brick).name@"/"@%BLID@".txt");   
   while(!%reader.isEOF())
   {
    %count++;
    %line = %reader.readLine();
    if(%count == %table) {
    %madeChange = true;
    %line = %line SPC %var1;
    %file.writeLine(%line);
      } else {
   %file.writeLine(%line);
      }
   }
   %reader.close();
   %reader.delete();
   %brick = getBrickGroupFromObject(%this).bl_id;
   %this.onDatabaseQuery(%client); 
   %file.close();
   %file.delete();
   
   if(%madeChange != true)
   {
    commandToClient(%client, 'MessageBoxOK', "Database Error", "Phrase Error:Unable to append to row.\nRow was not found.");
    return;
   }
}

function fxDTSBrick::setDatabaseRow(%this,%BLID,%var1,%table,%client)
{
   if(%table <= 0)
   {
     commandToClient(%client, 'MessageBoxOK', "Database Error", "Phrase Error:Unable to select row:" SPC %table);
     %this.onDataBaseError(%client);
     return;
   }
   %count = 0;
   %brick = getBrickGroupFromObject(%this).bl_id;
   if(isFile("config/database/data/event_files/database/"@findClientByBL_ID(%brick).name@"/"@%BLID@".txt") == false)
   {
    commandToClient(%client, 'MessageBoxOK', "Database Error", "Phrase Error:Unknown Database");
    %this.onDataBaseError(%client);
    return;  
   }
   %reader = new FileObject();
   %reader.openForRead("config/database/data/event_files/database/"@findClientByBL_ID(%this.stackbl_id).name@"/"@%BLID@".txt");
   %file = new FileObject();
   %file.openForWrite("config/database/data/event_files/database/"@findClientByBL_ID(%brick).name@"/"@%BLID@".txt");   
   while(!%reader.isEOF())
   {
    %count++;
    %line = %reader.readLine();
    if(%count == %table) {
    %madeChange = true;
    %line = %BLID SPC %var1;
    %file.writeLine(%line);
      } else {
   %file.writeLine(%line);
      }
   }
   %reader.close();
   %reader.delete();
   %brick = getBrickGroupFromObject(%this).bl_id;
   %this.onDatabaseQuery(%client); 
   %file.close();
   %file.delete();
   
   if(%madeChange != true)
   {
    commandToClient(%client, 'MessageBoxOK', "Database Error", "Phrase Error:Unable to append to row.\nRow was not found.");
    %this.onDataBaseError(%client);    
    return;
   }
}


function fxDTSBrick::RemoveFromBLIDDatabase(%this,%BLID,%client)
{
   %brick = getBrickGroupFromObject(%this).bl_id;
   if(isFile("config/database/data/event_files/database/"@findClientByBL_ID(%brick).name@"/"@%BLID@".txt") == false)
   {
    commandToClient(%client, 'MessageBoxOK', "Database Error", "Phrase Error:Unknown Database");
    %this.onDataBaseError(%client);
    return;  
   }
   %this.onDatabaseQuery(%client);
	fileDelete("config/database/data/event_files/database/"@findClientByBL_ID(%brick).name@"/"@%BLID@".txt");
}